OGRE-Next: Ogre::MaterialManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Ogre::MaterialManager Class Reference
Core » Materials

Class for managing Material settings for Ogre. More...

`#include <OgreMaterialManager.h>`

Inheritance diagram for Ogre::MaterialManager:
[legend]

## Classes
class | Listener
| Listener on any general material events. More...

## Public Member Functions
| MaterialManager ()
| Default constructor.
| ~MaterialManager () override
| Default destructor.
virtual Technique * | _arbitrateMissingTechniqueForActiveScheme (Material *mat, unsigned short lodIndex, const Renderable *rend)
| Internal method for sorting out missing technique for a scheme.
virtual unsigned short | _getActiveSchemeIndex () const
| Internal method - returns the active scheme index.
virtual unsigned short | _getSchemeIndex (const String &name)
| Internal method - returns index for a given material scheme name.
virtual const String & | _getSchemeName (unsigned short index)
| Internal method - returns name for a given material scheme index.
virtual void | _notifyAfterIlluminationPassesCreated (Technique *mat)
| Internal method for sorting out illumination passes for a scheme.
virtual void | _notifyBeforeIlluminationPassesCleared (Technique *mat)
| Internal method for sorting out illumination passes for a scheme.
virtual void | addListener (Listener *l, const Ogre::String &schemeName=BLANKSTRING)
| Add a listener to handle material events.
MaterialPtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new material.
virtual const String & | getActiveScheme () const
| Returns the name of the active material scheme.
MaterialPtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Get a resource by name.
virtual MaterialPtr | getDefaultSettings () const
| Returns a pointer to the default Material settings.
void | initialise ()
| Initialises the material manager, which also triggers it to parse all available .program and .material scripts.
void | parseScript (DataStreamPtr &stream, const String &groupName) override
virtual void | removeListener (Listener *l, const Ogre::String &schemeName=BLANKSTRING)
| Remove a listener handling material events.
virtual void | setActiveScheme (const String &schemeName)
| Sets the name of the active material scheme.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
| ~ResourceManager () override
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder () const override
| Gets the relative loading order of resources of this type.
virtual size_t | getMemoryBudget () const
| Get the limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryUsage () const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator ()
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType () const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns () const override
| Gets the file patterns which should be used to find scripts for this ResourceManager.
virtual bool | getVerbose ()
| Gets whether this manager and its resources habitually produce log output.
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse the definition of a set of resources from a script file.
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
virtual void | remove (const ResourcePtr &r)
| Remove a single resource.
virtual void | remove (const String &name)
| Remove a single resource by name.
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle.
virtual void | removeAll ()
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager.
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager.
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
virtual void | unload (const String &name)
| Unloads a single resource by name.
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< MaterialManager >
| Singleton ()
| ~Singleton ()

## Static Public Member Functions
static MaterialManager & | getSingleton ()
| Override standard Singleton retrieval.
static MaterialManager * | getSingletonPtr ()
| Override standard Singleton retrieval.
Static Public Member Functions inherited from Ogre::Singleton< MaterialManager >
static MaterialManager & | getSingleton ()
static MaterialManager * | getSingletonPtr ()

## Static Public Attributes
static String | DEFAULT_SCHEME_NAME
| Default material scheme.

## Additional Inherited Members
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap
Public Attributes inherited from Ogre::ResourceManager
| OGRE_AUTO_MUTEX

## Detailed Description

Class for managing Material settings for Ogre.

Remarks
  Materials control the eventual surface rendering properties of geometry. This class manages the library of materials, dealing with programmatic registrations and lookups, as well as loading predefined Material settings from scripts.

  When loaded from a script, a Material is in an 'unloaded' state and only stores the settings required. It does not at that stage load any textures. This is because the material settings may be loaded 'en masse' from bulk material script files, but only a subset will actually be required.

  Because this is a subclass of ResourceManager, any files loaded will be searched for in any path or archive added to the resource paths/archives. See ResourceManager for details.

  For a definition of the material script format, see the Tutorials/MaterialScript.html file.

## Constructor & Destructor Documentation

## ◆ MaterialManager()

Ogre::MaterialManager::MaterialManager | ( |  | ) |

Default constructor.

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~MaterialManager()

Ogre::MaterialManager::~MaterialManager | ( |  | ) |
| override

Default destructor.

## Member Function Documentation

## ◆ _arbitrateMissingTechniqueForActiveScheme()

virtual Technique * Ogre::MaterialManager::_arbitrateMissingTechniqueForActiveScheme | ( | Material * | mat,
|  | unsigned short | lodIndex,
|  | const Renderable * | rend )
| virtual

Internal method for sorting out missing technique for a scheme.

## ◆ _getActiveSchemeIndex()

virtual unsigned short Ogre::MaterialManager::_getActiveSchemeIndex | ( |  | ) | const
| virtual

Internal method - returns the active scheme index.

See also
  Technique::setSchemeName

## ◆ _getSchemeIndex()

virtual unsigned short Ogre::MaterialManager::_getSchemeIndex | ( | const String & | name | ) |
| virtual

Internal method - returns index for a given material scheme name.

See also
  Technique::setSchemeName

## ◆ _getSchemeName()

virtual const String & Ogre::MaterialManager::_getSchemeName | ( | unsigned short | index | ) |
| virtual

Internal method - returns name for a given material scheme index.

See also
  Technique::setSchemeName

## ◆ _notifyAfterIlluminationPassesCreated()

virtual void Ogre::MaterialManager::_notifyAfterIlluminationPassesCreated | ( | Technique * | mat | ) |
| virtual

Internal method for sorting out illumination passes for a scheme.

## ◆ _notifyBeforeIlluminationPassesCleared()

virtual void Ogre::MaterialManager::_notifyBeforeIlluminationPassesCleared | ( | Technique * | mat | ) |
| virtual

Internal method for sorting out illumination passes for a scheme.

## ◆ addListener()

virtual void Ogre::MaterialManager::addListener | ( | Listener * | l,
|  | const Ogre::String & | schemeName = BLANKSTRING )
| virtual

Add a listener to handle material events.

If schemeName is supplied, the listener will only receive events for that certain scheme.

References Ogre::BLANKSTRING.

## ◆ create()

MaterialPtr Ogre::MaterialManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new material.

See also
  ResourceManager::createResource

## ◆ getActiveScheme()

virtual const String & Ogre::MaterialManager::getActiveScheme | ( |  | ) | const
| virtual

Returns the name of the active material scheme.

See also
  Technique::setSchemeName

## ◆ getByName()

MaterialPtr Ogre::MaterialManager::getByName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Get a resource by name.

See also
  ResourceManager::getResourceByName

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getDefaultSettings()

virtual MaterialPtr Ogre::MaterialManager::getDefaultSettings | ( |  | ) | const
| inlinevirtual

Returns a pointer to the default Material settings.

Remarks
  Ogre comes configured with a set of defaults for newly created materials. If you wish to have a different set of defaults, simply call this method and change the returned Material's settings. All materials created from then on will be configured with the new defaults you have specified.

  The default settings begin as a single Technique with a single, non-programmable Pass:
  - ambient = ColourValue::White
  - diffuse = ColourValue::White
  - specular = ColourValue::Black
  - emmissive = ColourValue::Black
  - shininess = 0
  - No texture unit settings (& hence no textures)
  - SourceBlendFactor = SBF_ONE
  - DestBlendFactor = SBF_ZERO (no blend, replace with new colour)
  - Depth buffer checking on
  - Depth buffer writing on
  - Depth buffer comparison function = CMPF_LESS_EQUAL
  - Colour buffer writing on for all channels
  - Culling mode = CULL_CLOCKWISE
  - Ambient lighting = ColourValue(0.5, 0.5, 0.5) (mid-grey)
  - Dynamic lighting enabled
  - Gourad shading mode
  - Bilinear texture filtering

## ◆ getSingleton()

static MaterialManager & Ogre::MaterialManager::getSingleton | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References MaterialManager().

## ◆ getSingletonPtr()

static MaterialManager * Ogre::MaterialManager::getSingletonPtr | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References MaterialManager().

## ◆ initialise()

void Ogre::MaterialManager::initialise | ( |  | ) |

Initialises the material manager, which also triggers it to parse all available .program and .material scripts.

## ◆ parseScript()

void Ogre::MaterialManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName )
| overridevirtual

See also
  ScriptLoader::parseScript

Implements Ogre::ScriptLoader.

## ◆ removeListener()

virtual void Ogre::MaterialManager::removeListener | ( | Listener * | l,
|  | const Ogre::String & | schemeName = BLANKSTRING )
| virtual

Remove a listener handling material events.

If the listener was added with a custom scheme name, it needs to be supplied here as well.

References Ogre::BLANKSTRING.

## ◆ setActiveScheme()

virtual void Ogre::MaterialManager::setActiveScheme | ( | const String & | schemeName | ) |
| virtual

Sets the name of the active material scheme.

See also
  Technique::setSchemeName

## Member Data Documentation

## ◆ DEFAULT_SCHEME_NAME

String Ogre::MaterialManager::DEFAULT_SCHEME_NAME
| static

Default material scheme.

The documentation for this class was generated from the following file:

- OgreMaterialManager.h